#include <amxmodx> 
#include <engine>

#define PLUGIN "Reconnect Ban"
#define VERSION "1.0"
#define AUTHOR "DarkGL" 

new Array: clientsIP;

new Float:minTime;

public findIp( userIp[] ){
	new arrayIp[ 64 ];
	
	for(new iPosition = 0; iPosition < ArraySize( clientsIP ) ; iPosition++ ) {
		ArrayGetString( clientsIP , iPosition , arrayIp , charsmax( arrayIp ) );
		
		if( equal( arrayIp , userIp ) ){
			return iPosition;
		}
	}
	
	return -1;
}

public delayedKick(user[]) {
	server_cmd("kick #%d" , user[ 0 ] );
}

public cleanArray( userIp[] ) {
	new positionIp = findIp( userIp );
	
	if( positionIp == -1 ){
		return ;
	}
	
	ArrayDeleteItem( clientsIP , positionIp );
}

public client_authorized(id) {
	if( is_user_bot( id ) || is_user_hltv( id ) ) {
		return PLUGIN_CONTINUE;
	}
	
	if( get_user_flags( id ) & ADMIN_IMMUNITY ){
		return PLUGIN_CONTINUE;
	}
	
	new userIP[ 64 ],
		userName[ 64 ],
		authId[ 64 ];
	
	get_user_ip( id, userIP, charsmax( userIP ) , 0 );
	get_user_name( id, userName, charsmax( userName ) );
	get_user_authid( id , authId , charsmax( authId ) );
	
	new positionIp = findIp( userIP );
	
	if( positionIp == -1 ){
		return PLUGIN_CONTINUE;
	}
	
	
	new userid[ 1 ];
	
	userid[ 0 ] = get_user_userid( id );
	
	log_amx("^"%s<%s><%d><%s><>^"", userName, userIP, get_user_userid(id), authId );
	
	new szText[ 256 ];
	format( szText, charsmax( szText ) , "Player %s kicked after usage reconnect command", userName );
	
	set_hudmessage( 255, 0, 0, 0.05, 0.70, 0, 5.0, 6.0, 6.0, 0.15, 3 );
	show_hudmessage( 0 , "%s" , szText );
	
	client_cmd( id , "echo [AMXX] You used command RECONNECT within %f, please reconnect after %f sec", minTime );
	
	set_task( 1.0 , "delayedKick", _ ,userid, 1 );
	
	return PLUGIN_CONTINUE;
}

public client_disconnect(id) {
	if ( is_user_bot( id ) || is_user_hltv( id ) ) {
		return PLUGIN_CONTINUE;
	}
	
	new userIp[ 64 ];
	
	get_user_ip( id, userIp, charsmax( userIp ) , 0 );
	
	new positionIp = findIp( userIp );
	
	if( positionIp != -1 ){
		return PLUGIN_CONTINUE;
	}
	
	ArrayPushString( clientsIP , userIp );
	
	set_task( minTime, "cleanArray", _ , userIp , sizeof( userIp ) );
	
	return PLUGIN_CONTINUE;
}

public plugin_init() { 
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	register_cvar( "amx_minreconnecttime" , "20.0" );
	
	clientsIP = ArrayCreate( 64 , get_maxplayers() );
}

public plugin_cfg(){
	minTime = get_cvar_float( "amx_minreconnecttime" );
}